Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OptInPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OptInPhase.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OptInPhase.java	(revision 24)
@@ -5,4 +5,7 @@
 import java.util.Map;
 import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
 
 import geniusweb.actions.Action;
@@ -20,12 +23,21 @@
 public class OptInPhase extends DefaultPhase {
 
-	protected OptInPhase(Phase prevPhase, PartyStates partyStates,
-			Long deadlinems, VotingEvaluator evaluator) {
-		super(prevPhase, partyStates, deadlinems, evaluator);
+	/**
+	 * The votes received in the {@link VotingPhase}
+	 */
+	private final List<Votes> votes;
+
+	@JsonCreator
+	protected OptInPhase(@JsonProperty("votes") List<Votes> votes,
+			@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluator evaluator) {
+		super(partyStates, deadlinems, evaluator);
+		this.votes = votes;
 	}
 
 	@Override
 	public Inform getInform() {
-		return new OptIn(((VotingPhase) prevPhase).getVotes());
+		return new OptIn(votes);
 	}
 
@@ -35,7 +47,7 @@
 			checkAction(actor, action, now);
 			if (action instanceof Votes)
-				checkExtends(action);
+				checkExtends((Votes) action);
 
-			return new OptInPhase(prevPhase, partyStates.with(action), deadline,
+			return new OptInPhase(votes, partyStates.with(action), deadline,
 					evaluator);
 
@@ -48,18 +60,15 @@
 	 * Check that this action extends previous action.
 	 * 
-	 * @param action
-	 * @param phase
+	 * @param newvotes new {@link Votes} just received
 	 * @throws ProtocolException if this action does not correctly extend
 	 *                           previous vote.
 	 */
-	private void checkExtends(Action action) throws ProtocolException {
-
-		Votes votes = (Votes) action;
-		PartyId actor = action.getActor();
+	private void checkExtends(Votes newvotes) throws ProtocolException {
+		PartyId actor = newvotes.getActor();
 		// this actor is active so he must have voted in previous round.
-		Votes prevVotes = ((VotingPhase) prevPhase).getVotes().stream()
-				.filter(v -> v.getActor().equals(actor)).findFirst().get();
-		if (!(votes.isExtending(prevVotes)))
-			throw new ProtocolException("New votes " + action
+		Votes prevVotes = votes.stream().filter(v -> v.getActor().equals(actor))
+				.findFirst().get();
+		if (!(newvotes.isExtending(prevVotes)))
+			throw new ProtocolException("New votes " + newvotes
 					+ " does not extend previous vote " + prevVotes, actor);
 	}
@@ -67,6 +76,5 @@
 	@Override
 	public OptInPhase with(ProtocolException e) {
-		return new OptInPhase(prevPhase, partyStates.with(e), deadline,
-				evaluator);
+		return new OptInPhase(votes, partyStates.with(e), deadline, evaluator);
 	}
 
@@ -84,11 +92,10 @@
 		PartyStates finalStates = states.with(newAgree);
 
-		return new OptInPhase(prevPhase, finalStates, deadline, evaluator);
+		return new OptInPhase(votes, finalStates, deadline, evaluator);
 	}
 
 	@Override
 	public OfferPhase checkedNext(long newdeadline) {
-		return new OfferPhase(this, partyStates.flush(), newdeadline,
-				evaluator);
+		return new OfferPhase(partyStates.flush(), newdeadline, evaluator);
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/Phase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/Phase.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/Phase.java	(revision 24)
@@ -2,8 +2,9 @@
 
 import java.util.List;
-import java.util.Set;
 
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
 import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
 import geniusweb.actions.Action;
@@ -17,7 +18,20 @@
  * A Phase is a part of the round structure. In each round parties have to take
  * multiple actions. Each action is part of a phase.
- *
+ * 
+ * Invariant: A phase object handles negotiation events, ensuring that the
+ * events are handled according to the possible actions in this phase. A phase
+ * object must always remain in a consistent state. It does so by modifying the
+ * contained {@link PartyStates} as needed.
+ * <p>
+ * The standard exception handling is assumed: unchecked exceptions are thrown
+ * only if there is a bug in the protocol. Because none of the functions in this
+ * interface throws, any error must be either ignored or the party must be
+ * kicked.
  */
-@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonSubTypes({ @JsonSubTypes.Type(value = OfferPhase.class),
+		@JsonSubTypes.Type(value = OptInPhase.class),
+		@JsonSubTypes.Type(value = VotingPhase.class) })
 public interface Phase {
 	public static final Long PHASE_MAXTIME = 30000l; // 30sec
@@ -28,9 +42,9 @@
 	 * handled by updating the PartyStates
 	 * 
-	 * @param prevPhases the list of all previous phases
-	 * @param actor      the real actor
-	 * @param action     the action submitted by actor, which this phase can
-	 *                   really handle.
-	 * @param now        the current time
+	 * @param actor  the real actor (may differ from the actor contained in the
+	 *               action)
+	 * @param action the action submitted by actor, which this phase can really
+	 *               handle.
+	 * @param now    the current time
 	 * @return new VotingPhase
 	 */
@@ -73,6 +87,6 @@
 	 * after {@link #finish()}
 	 * 
-	 * @param now      the curren time
-	 * @param duration the max duration of the next phase. Must be between
+	 * @param now      the current time
+	 * @param duration the max duration (ms) of the next phase. Must be between
 	 *                 {@link #PHASE_MINTIME} and {@link #PHASE_MAXTIME}. Also
 	 *                 make sure that now+duration is at most at the total
@@ -83,7 +97,5 @@
 
 	/**
-	 * Get the voting evaluator
-	 * 
-	 * @return
+	 * @return the voting evaluator
 	 */
 	public VotingEvaluator getEvaluator();
@@ -97,8 +109,6 @@
 
 	/**
-	 * @param now the current time
-	 * 
 	 * @return the party states. Notice that someone must call
-	 *         {@link PartyStates#finish(Set)} if passed the deadline.
+	 *         {@link PartyStates#finish()} if passed the deadline.
 	 */
 	public PartyStates getPartyStates();
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java	(revision 24)
@@ -3,4 +3,8 @@
 import java.util.Arrays;
 import java.util.List;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
 
 import geniusweb.actions.Action;
@@ -10,4 +14,5 @@
 import geniusweb.inform.Inform;
 import geniusweb.inform.Voting;
+import geniusweb.issuevalue.Bid;
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.session.mopac.PartyStates;
@@ -16,7 +21,16 @@
 public class VotingPhase extends DefaultPhase {
 
-	VotingPhase(Phase prevPhase, PartyStates partyStates, Long deadlinems,
-			VotingEvaluator evaluator) {
-		super(prevPhase, partyStates, deadlinems, evaluator);
+	/**
+	 * the offers received in the {@link OfferPhase}
+	 */
+	private final List<Bid> offers;
+
+	@JsonCreator
+	protected VotingPhase(@JsonProperty("offers") List<Bid> offers,
+			@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluator evaluator) {
+		super(partyStates, deadlinems, evaluator);
+		this.offers = offers;
 	}
 
@@ -28,5 +42,5 @@
 			return this.with(ex);
 		}
-		return new VotingPhase(prevPhase, partyStates.with(action), deadline,
+		return new VotingPhase(offers, partyStates.with(action), deadline,
 				evaluator);
 	}
@@ -34,11 +48,10 @@
 	@Override
 	public Inform getInform() {
-		return new Voting(((OfferPhase) prevPhase).getOffers(),
-				partyStates.getPowers());
+		return new Voting(offers, partyStates.getPowers());
 	}
 
 	@Override
 	public VotingPhase with(ProtocolException e) {
-		return new VotingPhase(prevPhase, partyStates.with(e), deadline,
+		return new VotingPhase(offers, partyStates.with(e), deadline,
 				evaluator);
 	}
@@ -46,5 +59,5 @@
 	@Override
 	public VotingPhase finish() {
-		return new VotingPhase(prevPhase, partyStates.finish(), deadline,
+		return new VotingPhase(offers, partyStates.finish(), deadline,
 				evaluator);
 	}
@@ -52,5 +65,6 @@
 	@Override
 	protected Phase checkedNext(long deadln) {
-		return new OptInPhase(this, partyStates.flush(), deadln, evaluator);
+		return new OptInPhase(getVotes(), partyStates.flush(), deadln,
+				evaluator);
 	}
 
@@ -60,3 +74,12 @@
 	}
 
+	/**
+	 * @return all votes done in this phase.
+	 */
+	public List<Votes> getVotes() {
+		return partyStates.getActions().stream()
+				.filter(act -> act instanceof Votes).map(act -> (Votes) act)
+				.collect(Collectors.toList());
+	}
+
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 24)
@@ -38,11 +38,11 @@
 
 /**
- * 
- * All parties are first sent the {@link SessionSettings}. Only parties
- * specified initially in the settings do participate.
+ * The protocol runs as follows
  * <ol>
- * The protocol tries to start all parties. If not all parties start, the
+ * <li>The protocol tries to start all parties. If not all parties start, the
  * parties are freed up and another attempt is done to start all parties some
  * time later.
+ * <li>All parties are sent the {@link SessionSettings}. Only parties specified
+ * initially in the settings do participate.
  * <li>The session deadline clock now starts ticking.
  * <li>All parties are sent their settings.
@@ -61,5 +61,5 @@
  * the protocol.
  * <p>
- * Threadsafe: all entrypoints are synhronized.
+ * Thread safe: all entry points are synchronized.
  */
 public class SAOP extends DefaultListenable<ProtocolEvent>
@@ -79,5 +79,6 @@
 	/**
 	 * 
-	 * @param state normally the initial state coming from SAOPSettings
+	 * @param state  normally the initial state coming from SAOPSettings
+	 * @param logger the Reporter to log to
 	 */
 	public SAOP(SAOPState state, Reporter logger) {
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 24)
@@ -27,5 +27,5 @@
 	 *                     protocol. But SAOP can be initialized with less, for
 	 *                     use in TournamentSettings.
-	 * @param deadline
+	 * @param deadline     the deadline of the negotiation
 	 */
 	@JsonCreator
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 24)
@@ -33,5 +33,5 @@
 	/**
 	 * 
-	 * @param actions
+	 * @param actions       the actions done by the parties
 	 * @param conns         the existing party connections. we assume ownership
 	 *                      of this so it should not be modified although
@@ -88,7 +88,5 @@
 	/**
 	 * 
-	 * @param e             the error that occured
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
+	 * @param e the error that occured
 	 * @return a new state with the error set.
 	 */
@@ -160,11 +158,9 @@
 
 	/**
-	 * @param actor         the actor that did this action. Can be used to check
-	 *                      if action is valid. NOTICE caller has to make sure
-	 *                      the current state is not final.
-	 * @param action        the action that was proposed by actor.
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
-	 * @return new SessionState with the action added as last action.
+	 * @param actor  the actor that did this action. Can be used to check if
+	 *               action is valid. NOTICE caller has to make sure the current
+	 *               state is not final.
+	 * @param action the action that was proposed by actor.
+	 * @return new SAOPState with the action added as last action.
 	 */
 
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 24)
@@ -44,26 +44,26 @@
 	/**
 	 * 
-	 * @param actions    value for actions done so far. null equals to empty
-	 *                   list
-	 * @param conns      the currently existing connections. Can be empty/null.
-	 *                   Each connection represents another party. Normally the
-	 *                   connections are in the order SHAOP1,COB1,SHAOP2,COB2,..
-	 *                   so 2 parties for each team. The protocol should check
-	 *                   this.
-	 * @param progr      the {@link Progress} that governs this session. Can be
-	 *                   null if session did not yet start.
-	 * @param settings   the settings used for the session
-	 * @param e          the exception that occured, usually null. All errors
-	 *                   occuring due to faulty {@link Action}s translate to
-	 *                   {@link ProtocolException}s. All errors in our own code
-	 *                   are bugs (not ProtocolExceptions) and should result in
-	 *                   a throw.
-	 * @param teamNr     the teamnr (0,1,2..) that has the turn. 2* gives index
-	 *                   {@link #connections} and settings
-	 * @param partyNrs   a map for each known PartyId to a number. The number is
-	 *                   the index in both {@link SHAOPSettings#getTeams()} and
-	 *                   in {@link #connections}. null is empyt map.
-	 * @param totalSpent total accumulated elicitation costs so far. only SHAOP
-	 *                   parties accumulate costs. null = empty map
+	 * @param actions  value for actions done so far. null equals to empty list
+	 * @param conns    the currently existing connections. Can be empty/null.
+	 *                 Each connection represents another party. Normally the
+	 *                 connections are in the order SHAOP1,COB1,SHAOP2,COB2,..
+	 *                 so 2 parties for each team. The protocol should check
+	 *                 this.
+	 * @param progr    the {@link Progress} that governs this session. Can be
+	 *                 null if session did not yet start.
+	 * @param settings the settings used for the session
+	 * @param e        the exception that occured, usually null. All errors
+	 *                 occuring due to faulty {@link Action}s translate to
+	 *                 {@link ProtocolException}s. All errors in our own code
+	 *                 are bugs (not ProtocolExceptions) and should result in a
+	 *                 throw.
+	 * @param teamNr   the teamnr (0,1,2..) that has the turn. 2* gives index
+	 *                 {@link #connections} and settings
+	 * @param partyNrs a map for each known PartyId to a number. The number is
+	 *                 the index in both {@link SHAOPSettings#getTeams()} and in
+	 *                 {@link #connections}. null is empyt map.
+	 * @param spent    total accumulated elicitation costs so far for each
+	 *                 party. only SHAOP parties accumulate costs. null = empty
+	 *                 map
 	 */
 	@JsonCreator
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 24)
@@ -85,5 +85,6 @@
 	/**
 	 * 
-	 * @param state normally the initial state coming from SAOPSettings
+	 * @param state  normally the initial state coming from SAOPSettings
+	 * @param logger the {@link Reporter} to use
 	 */
 	public SHAOP(SHAOPState state, Reporter logger) {
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 24)
@@ -38,4 +38,23 @@
 	 * see {@link BareSHAOPState}.
 	 */
+	/**
+	 * 
+	 * @param actions       see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param conns         see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param progress      see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param settings      see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param e             see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param teamNr        see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param partytNumbers see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 * @param spent         see
+	 *                      {@link BareSHAOPState#BareSHAOPState(List, ProtocolToPartyConnections, Progress, SHAOPSettings, ProtocolException, int, Map, Map)}.
+	 */
 	@JsonCreator
 	public SHAOPState(@JsonProperty("actions") List<Action> actions,
@@ -72,6 +91,6 @@
 	/**
 	 * 
-	 * @param party
-	 * @return true iff party is a SHAOP party.
+	 * @param party the {@link PartyId} to test
+	 * @return true iff party is a SHAOP party (not a COB party).
 	 */
 	public boolean isShaopParty(PartyId party) {
@@ -81,5 +100,5 @@
 	/**
 	 * 
-	 * @return the team leader {@link PartyId}s.
+	 * @return the team leader {@link PartyId}s which are the SHAOP parties.
 	 */
 	private Set<PartyId> getLeaders() {
@@ -149,7 +168,5 @@
 	/**
 	 * 
-	 * @param e             the error that occured
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
+	 * @param e the error that occured
 	 * @return a new state with the error set.
 	 */
@@ -201,10 +218,8 @@
 
 	/**
-	 * @param actor         the actor that did this action. Can be used to check
-	 *                      if action is valid. NOTICE caller has to make sure
-	 *                      the current state is not final.
-	 * @param action        the action that was proposed by actor.
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
+	 * @param actor  the actor that did this action. Can be used to check if
+	 *               action is valid. NOTICE caller has to make sure the current
+	 *               state is not final.
+	 * @param action the action that was proposed by actor.
 	 * @return new SessionState with the action added as last action.
 	 */
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 24)
@@ -34,5 +34,5 @@
 	/**
 	 * 
-	 * @param state
+	 * @param state  the {@link AllPermutationsState}
 	 * @param logger used for all logging, about the tournament, and the created
 	 *               the session and protocols.
@@ -81,6 +81,4 @@
 			long now = System.currentTimeMillis();
 			if (sessionstate.isFinal(now)) {
-				// List<TeamOfPartiesAndProfiles> participants =
-				// sessionstate.getSettings().getParticipants()
 				SessionResult result = sessionstate.getResult();
 				state = state.with(result);
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 23)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 24)
@@ -69,23 +69,21 @@
 	/**
 	 * 
-	 * @param teams             a list of {@link Team}s. Must contain at least
-	 *                          {@link #teamsPerSession} elements. The
-	 *                          <teamsize> must match the protocol: (SAOP:1,
-	 *                          SHAOP:2)
-	 * @param reuseTeams        if true, we use PermutationsWithReturn, if false
-	 *                          we use PermutationsWithoutReturn to create the
-	 *                          teams.
-	 * @param plists            list of available {@link ProfileList}s to be
-	 *                          permutated over the teams. Each
-	 *                          {@link ProfileList} must contain <teamsize>
-	 *                          elements.
-	 * @param teamsPerSession   number of parties per session, must be at least
-	 *                          2.
-	 * @param sesettings        The generic {@link SessionSetting}.
-	 *                          {@link SessionSettings#with(PartyWithProfile)}
-	 *                          will be used to add the required
-	 *                          {@link PartyWithProfile}s
-	 * @param numberTournaments the number of times the tournament should be
-	 *                          run.
+	 * @param teams           a list of {@link Team}s. Must contain at least
+	 *                        {@link #teamsPerSession} elements. The
+	 *                        {@link #teamsPerSession} must match the protocol:
+	 *                        (SAOP:1, SHAOP:2)
+	 * @param reuseTeams      if true, we use PermutationsWithReturn, if false
+	 *                        we use PermutationsWithoutReturn to create the
+	 *                        teams.
+	 * @param plists          list of available {@link ProfileList}s to be
+	 *                        permutated over the teams. Each
+	 *                        {@link ProfileList} must contain
+	 *                        {@link #teamsPerSession} elements.
+	 * @param teamsPerSession number of parties per session, must be at least 2.
+	 * @param sesettings      The generic {@link SessionSettings}.
+	 *                        {@link SessionSettings#with(TeamOfPartiesAndProfiles)}
+	 *                        will be used to add the required
+	 *                        {@link TeamOfPartiesAndProfiles}s
+	 * @param nTournaments    the number of times the tournament should be run.
 	 */
 	@JsonCreator
Index: /protocol/src/test/java/geniusweb/protocol/session/amop/WillBeCalledTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/amop/WillBeCalledTest.java	(revision 24)
+++ /protocol/src/test/java/geniusweb/protocol/session/amop/WillBeCalledTest.java	(revision 24)
@@ -0,0 +1,37 @@
+package geniusweb.protocol.session.amop;
+
+import static org.junit.Assert.assertEquals;
+
+import org.junit.Test;
+
+public class WillBeCalledTest {
+	int counter;
+
+	@Test
+	public void testDeadline() throws InterruptedException {
+		counter = 0;
+		new WillBeCalled(() -> {
+			counter++;
+		}, 100l);
+		assertEquals(0, counter);
+		Thread.sleep(200);
+		assertEquals(1, counter);
+		Thread.sleep(200);
+		assertEquals(1, counter);
+
+	}
+
+	@Test
+	public void testManual() throws InterruptedException {
+		counter = 0;
+		WillBeCalled w = new WillBeCalled(() -> {
+			counter++;
+		}, 100l);
+		assertEquals(0, counter);
+		w.complete();
+		assertEquals(1, counter);
+		Thread.sleep(200);
+		assertEquals(1, counter);
+
+	}
+}
